## synergy 1.14.1.32%2Bdfsg

=== CMakeLists.txt ===
# Synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
#
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
#
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.4)
project (synergy-core C CXX)

if (DEFINED ENV{SYNERGY_NO_LEGACY})
    option (SYNERGY_BUILD_LEGACY_GUI "Build the legacy GUI" OFF)
    option (SYNERGY_BUILD_LEGACY_SERVICE "Build the legacy service (synergyd)" OFF)
    option (SYNERGY_BUILD_LEGACY_INSTALLER "Build the legacy installer" OFF)
else()
    option (SYNERGY_BUILD_LEGACY_GUI "Build the legacy GUI" ON)
    option (SYNERGY_BUILD_LEGACY_SERVICE "Build the legacy service (synergyd)" ON)
    option (SYNERGY_BUILD_LEGACY_INSTALLER "Build the legacy installer" ON)
endif()
option (BUILD_TESTS "Override building of tests" ON)
option (ENABLE_COVERAGE "Build with coverage")

if ($ENV{SYNERGY_ENTERPRISE})
    option (SYNERGY_ENTERPRISE "Build Enterprise" ON)
else()
    option (SYNERGY_ENTERPRISE "Build Enterprise" OFF)
endif()

set (CMAKE_CXX_STANDARD 14)
set (CMAKE_CXX_EXTENSIONS OFF)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

if (ENABLE_COVERAGE)
    # Add Code Coverage
    include(cmake/CodeCoverage.cmake)
    append_coverage_compiler_flags()
    setup_target_for_coverage_gcovr_xml(
            NAME coverage
            EXECUTABLE unittests
            BASE_DIRECTORY "${PROJECT_SOURCE_DIR}/src"
            EXCLUDE "ext/*")

endif()

if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions (-DNDEBUG)
endif()

#
# Synergy version
#
include (cmake/Version.cmake)

# TODO: Find out why we need these, and remove them
if (COMMAND cmake_policy)
    cmake_policy (SET CMP0003 NEW)
    cmake_policy (SET CMP0005 NEW)
endif()

# Add headers to source list
if (${CMAKE_GENERATOR} STREQUAL "Unix Makefiles")
    set (SYNERGY_ADD_HEADERS FALSE)
else()
    set (SYNERGY_ADD_HEADERS TRUE)
endif()



set (libs)
include_directories (BEFORE SYSTEM ${PROJECT_SOURCE_DIR}/ext/googletest/googletest/include)

if (UNIX)
    if (NOT APPLE)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
    endif()

    # For config.h, detect the libraries, functions, etc.
    include (CheckIncludeFiles)
    include (CheckLibraryExists)
    include (CheckFunctionExists)
    include (CheckTypeSize)
    include (CheckIncludeFileCXX)
    include (CheckSymbolExists)
    include (CheckCSourceCompiles)

    check_include_file_cxx (istream HAVE_ISTREAM)
    check_include_file_cxx (ostream HAVE_OSTREAM)
    check_include_file_cxx (sstream HAVE_SSTREAM)

    check_include_files (inttypes.h HAVE_INTTYPES_H)
    check_include_files (locale.h HAVE_LOCALE_H)
    check_include_files (memory.h HAVE_MEMORY_H)
    check_include_files (stdlib.h HAVE_STDLIB_H)
    check_include_files (strings.h HAVE_STRINGS_H)
    check_include_files (string.h HAVE_STRING_H)
    check_include_files (sys/select.h HAVE_SYS_SELECT_H)
    check_include_files (sys/socket.h HAVE_SYS_SOCKET_H)
    check_include_files (sys/stat.h HAVE_SYS_STAT_H)
    check_include_files (sys/time.h HAVE_SYS_TIME_H)
    check_include_files (sys/utsname.h HAVE_SYS_UTSNAME_H)
    check_include_files (unistd.h HAVE_UNISTD_H)
    check_include_files (wchar.h HAVE_WCHAR_H)

    check_function_exists (getpwuid_r HAVE_GETPWUID_R)
    check_function_exists (gmtime_r HAVE_GMTIME_R)
    check_function_exists (nanosleep HAVE_NANOSLEEP)
    check_function_exists (poll HAVE_POLL)
    check_function_exists (sigwait HAVE_POSIX_SIGWAIT)
    check_function_exists (strftime HAVE_STRFTIME)
    check_function_exists (vsnprintf HAVE_VSNPRINTF)
    check_function_exists (inet_aton HAVE_INET_ATON)

    # For some reason, the check_function_exists macro doesn't detect
    # the inet_aton on some pure Unix platforms (e.g. sunos5). So we
    # need to do a more detailed check and also include some extra libs.
    if (NOT HAVE_INET_ATON)
        set (CMAKE_REQUIRED_LIBRARIES nsl)

        check_c_source_compiles (
            "#include <arpa/inet.h>\n int main() { inet_aton (0, 0); }"
            HAVE_INET_ATON_ADV)

        set (CMAKE_REQUIRED_LIBRARIES)

        if (HAVE_INET_ATON_ADV)
            # Override the previous fail.
            set (HAVE_INET_ATON 1)

            # Assume that both nsl and socket will be needed,
            # it seems safe to add socket on the back of nsl,
            # since socket only ever needed when nsl is needed.
            list (APPEND libs nsl socket)
        endif()

    endif()

    check_type_size (char SIZEOF_CHAR)
    check_type_size (int SIZEOF_INT)
    check_type_size (long SIZEOF_LONG)
    check_type_size (short SIZEOF_SHORT)

    # pthread is used on both Linux and Mac
    check_library_exists ("pthread" pthread_create "" HAVE_PTHREAD)
    if (HAVE_PTHREAD)
        list (APPEND libs pthread)
    else()
        message (FATAL_ERROR "Missing library: pthread")
    endif()


    if (APPLE)
        set (CMAKE_CXX_FLAGS "--sysroot ${CMAKE_OSX_SYSROOT} ${CMAKE_CXX_FLAGS} -DGTEST_USE_OWN_TR1_TUPLE=1")

        if(NOT CMAKE_OSX_DEPLOYMENT_TARGET)
            set(CMAKE_OSX_DEPLOYMENT_TARGET 11.0)
        endif()

        if(CMAKE_OSX_DEPLOYMENT_TARGET GREATER_EQUAL 11.0)
            set(SYNERGY_OSX_DEPLOYMENT_TARGET 1100)
        elseif(CMAKE_OSX_DEPLOYMENT_TARGET GREATER_EQUAL 10.15)
            set(SYNERGY_OSX_DEPLOYMENT_TARGET 1015)
        elseif(CMAKE_OSX_DEPLOYMENT_TARGET GREATER_EQUAL 10.14)
            set(SYNERGY_OSX_DEPLOYMENT_TARGET 1014)
        else()
            set(SYNERGY_OSX_DEPLOYMENT_TARGET 1013)
        endif()
        add_compile_definitions(OSX_DEPLOYMENT_TARGET=${SYNERGY_OSX_DEPLOYMENT_TARGET})

        find_library (lib_ScreenSaver ScreenSaver)
        find_library (lib_IOKit IOKit)
        find_library (lib_ApplicationServices ApplicationServices)
        find_library (lib_Foundation Foundation)
        find_library (lib_Carbon Carbon)

        list (APPEND libs
            ${lib_ScreenSaver}
            ${lib_IOKit}
            ${lib_ApplicationServices}
            ${lib_Foundation}
            ${lib_Carbon}
        )

        if(SYNERGY_OSX_DEPLOYMENT_TARGET GREATER_EQUAL 1014)
            find_library (lib_UserNotifications UserNotifications)
            list (APPEND libs
                ${lib_UserNotifications}
            )
        endif()

    else() # not-apple

        # add include dir for bsd (posix uses /usr/include/)
        set (CMAKE_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}:/usr/local/include")

        set (XKBlib "X11/Xlib.h;X11/XKBlib.h")
        set (CMAKE_EXTRA_INCLUDE_FILES "${XKBlib};X11/extensions/Xrandr.h")
        check_type_size ("XRRNotifyEvent" X11_EXTENSIONS_XRANDR_H)
        set (HAVE_X11_EXTENSIONS_XRANDR_H "${X11_EXTENSIONS_XRANDR_H}")
        set (CMAKE_EXTRA_INCLUDE_FILES)

        check_include_files ("${XKBlib};X11/extensions/dpms.h" HAVE_X11_EXTENSIONS_DPMS_H)
        check_include_files ("X11/extensions/Xinerama.h" HAVE_X11_EXTENSIONS_XINERAMA_H)
        check_include_files ("${XKBlib};X11/extensions/XKBstr.h" HAVE_X11_EXTENSIONS_XKBSTR_H)
        check_include_files ("X11/extensions/XKB.h" HAVE_XKB_EXTENSION)
        check_include_files ("X11/extensions/XTest.h" HAVE_X11_EXTENSIONS_XTEST_H)
        check_include_files ("${XKBlib}" HAVE_X11_XKBLIB_H)
        check_include_files ("X11/extensions/XInput2.h" HAVE_XI2)

        if (HAVE_X11_EXTENSIONS_DPMS_H)
            # Assume that function prototypes declared, when include exists.
            set (HAVE_DPMS_PROTOTYPES 1)
        endif()

        if (NOT HAVE_X11_XKBLIB_H)
            message (FATAL_ERROR "Missing header: " ${XKBlib})
        endif()

        check_library_exists ("SM;ICE" IceConnectionNumber "" HAVE_ICE)
        check_library_exists ("Xext;X11" DPMSQueryExtension "" HAVE_Xext)
        check_library_exists ("Xtst;Xext;X11" XTestQueryExtension "" HAVE_Xtst)
        check_library_exists ("Xinerama" XineramaQueryExtension "" HAVE_Xinerama)
        check_library_exists ("Xi" XISelectEvents "" HAVE_Xi)
        check_library_exists ("Xrandr" XRRQueryExtension "" HAVE_Xrandr)

        if (HAVE_ICE)

            # Assume we have SM if we have ICE.
            set (HAVE_SM 1)
            list (APPEND libs SM ICE)

        endif()

        if (HAVE_Xtst)

            # Xtxt depends on X11.
            set (HAVE_X11)
            list (APPEND libs Xtst X11)

        else()

            message (FATAL_ERROR "Missing library: Xtst")

        endif()

        if (HAVE_Xext)
            list (APPEND libs Xext)
        endif()

        if (HAVE_Xinerama)
            list (APPEND libs Xinerama)
        else (HAVE_Xinerama)
            if (HAVE_X11_EXTENSIONS_XINERAMA_H)
                set (HAVE_X11_EXTENSIONS_XINERAMA_H 0)
                message (WARNING "Old Xinerama implementation detected, disabled")
            endif()
        endif()

        if (HAVE_Xrandr)
            list (APPEND libs Xrandr)
        endif()

        # this was outside of the linux scope,
        # not sure why, moving it back inside.
        if (HAVE_Xi)
            list (APPEND libs Xi)
        endif()

    endif()

    # For config.h, set some static values; it may be a good idea to make
    # these values dynamic for non-standard UNIX compilers.
    set (ACCEPT_TYPE_ARG3 socklen_t)
    set (HAVE_CXX_BOOL 1)
    set (HAVE_CXX_CASTS 1)
    set (HAVE_CXX_EXCEPTIONS 1)
    set (HAVE_CXX_MUTABLE 1)
    set (HAVE_CXX_STDLIB 1)
    set (HAVE_PTHREAD_SIGNAL 1)
    set (SELECT_TYPE_ARG1 int)
    set (SELECT_TYPE_ARG234 " (fd_set *)")
    set (SELECT_TYPE_ARG5 " (struct timeval *)")
    set (STDC_HEADERS 1)
    set (TIME_WITH_SYS_TIME 1)
    set (HAVE_SOCKLEN_T 1)

    # For config.h, save the results based on a template (config.h.in).
    configure_file (res/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/src/lib/config.h)

    add_definitions (-DSYSAPI_UNIX=1 -DHAVE_CONFIG_H)

    if (APPLE)
        add_definitions (-DWINAPI_CARBON=1 -D_THREAD_SAFE)
    else()
        add_definitions (-DWINAPI_XWINDOWS=1)
    endif()

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD /O2 /Ob2")

    list (APPEND libs Wtsapi32 Userenv Wininet comsuppw Shlwapi)

    add_definitions (
        /DWIN32
        /D_WINDOWS
        /D_CRT_SECURE_NO_WARNINGS
        /DSYNERGY_VERSION=\"${SYNERGY_VERSION}\"
        /D_XKEYCHECK_H
    )
endif()

#
# OpenSSL
#
# Apple has to use static libraries because
# "Use of the Apple-provided OpenSSL libraries by apps is strongly discouraged."
# https://developer.apple.com/library/archive/documentation/Security/Conceptual/cryptoservices/SecureNetworkCommunicationAPIs/SecureNetworkCommunicationAPIs.html
if(APPLE)
    set(OPENSSL_USE_STATIC_LIBS TRUE)
endif()
find_package(OpenSSL REQUIRED)

#
# Check submodules
#
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
# Update submodules as needed
    option(GIT_SUBMODULE "Check submodules during build" ON)
    if(GIT_SUBMODULE)
        message(STATUS "Submodule update")
        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE GIT_SUBMOD_RESULT)
        if(NOT GIT_SUBMOD_RESULT EQUAL "0")

=== src/cmd/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2011 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(synergyc)
add_subdirectory(synergys)
add_subdirectory(syntool)

if (SYNERGY_BUILD_LEGACY_SERVICE)
    add_subdirectory(synergyd)
endif (SYNERGY_BUILD_LEGACY_SERVICE)

=== src/lib/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(arch)
add_subdirectory(base)
add_subdirectory(client)
add_subdirectory(common)
add_subdirectory(io)
add_subdirectory(ipc)
add_subdirectory(mt)
add_subdirectory(net)
add_subdirectory(platform)
add_subdirectory(server)
add_subdirectory(synergy)
add_subdirectory(shared)

=== src/test/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2011 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include_directories(
    ../../ext/googletest/googletest
    ../../ext/googletest/googletest/include
    ../../ext/googletest/googlemock
    ../../ext/googletest/googlemock/include)
    
add_library(gtest STATIC ../../ext/googletest/googletest/src/gtest-all.cc)
add_library(gmock STATIC ../../ext/googletest/googlemock/src/gmock-all.cc)

if (UNIX)
    # ignore warnings in gtest and gmock
    set_target_properties(gtest PROPERTIES COMPILE_FLAGS "-w")
    set_target_properties(gmock PROPERTIES COMPILE_FLAGS "-w")
endif()

add_subdirectory(integtests)
add_subdirectory(unittests)

=== src/cmd/synergyc/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(sources
    synergyc.cpp
)

if (WIN32)
    file(GLOB arch_headers "MSWindows*.h")
    file(GLOB arch_sources "MSWindows*.cpp")
    list(APPEND sources
        resource.h
        synergyc.ico
        synergyc.rc
        tb_error.ico
        tb_idle.ico
        tb_run.ico
        tb_wait.ico
        synergyc.exe.manifest
    )
elseif (APPLE)
    file(GLOB arch_headers "OSX*.h")
    file(GLOB arch_sources "OSX*.cpp")
elseif (UNIX)
    file(GLOB arch_headers "XWindows*.h")
    file(GLOB arch_sources "XWindows*.cpp")
endif()

list(APPEND sources ${arch_sources})
list(APPEND headers ${arch_headers})

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_executable(synergyc ${sources})
target_link_libraries(synergyc
    arch base client common io mt net ipc platform server synlib ${libs})

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    install (TARGETS synergyc DESTINATION ${SYNERGY_BUNDLE_BINARY_DIR})
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    install (TARGETS synergyc DESTINATION bin)
endif()

=== src/cmd/synergys/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(sources
    synergys.cpp
)

if (WIN32)
    file(GLOB arch_headers "MSWindows*.h")
    file(GLOB arch_sources "MSWindows*.cpp")
    list(APPEND sources
        resource.h
        synergys.ico
        synergys.rc
        tb_error.ico
        tb_idle.ico
        tb_run.ico
        tb_wait.ico
        synergys.exe.manifest
    )
elseif (APPLE)
    file(GLOB arch_headers "OSX*.h")
    file(GLOB arch_sources "OSX*.cpp")
elseif (UNIX)
    file(GLOB arch_headers "XWindows*.h")
    file(GLOB arch_sources "XWindows*.cpp")
endif()

list(APPEND sources ${arch_sources})
list(APPEND headers ${arch_headers})

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_executable(synergys ${sources})
target_link_libraries(synergys
    arch base client common io mt net ipc platform server synlib ${libs})

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    install (TARGETS synergys DESTINATION ${SYNERGY_BUNDLE_BINARY_DIR})
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    install (TARGETS synergys DESTINATION bin)
endif()

=== src/lib/arch/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

# arch
if (WIN32)
    file(GLOB arch_headers "win32/*.h")
    file(GLOB arch_sources "win32/*.cpp")
elseif (UNIX)
    file(GLOB arch_headers "unix/*.h")
    file(GLOB arch_sources "unix/*.cpp")
endif()

list(APPEND sources ${arch_sources})
list(APPEND headers ${arch_headers})

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_library(arch STATIC ${sources})

if (UNIX)
    target_link_libraries(arch ${CMAKE_DL_LIBS} ${libs})

    if (NOT APPLE)
        find_package (Qt5 COMPONENTS DBus)
        include_directories(${Qt5DBus_INCLUDE_DIRS})
        target_link_libraries (arch Qt5::DBus)
    endif()
endif()

=== src/lib/base/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_library(base STATIC ${sources})

if (UNIX)
    target_link_libraries(base common)
endif()

=== src/lib/client/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_library(client STATIC ${sources})

if (UNIX)
    target_link_libraries(client synlib io)
endif()

=== src/lib/io/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_library(io STATIC ${sources})

=== src/lib/mt/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

add_library(mt STATIC ${sources})

=== src/lib/platform/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if (WIN32)
    file(GLOB headers "MSWindows*.h")
    file(GLOB sources "MSWindows*.cpp")
elseif (APPLE)
    file(GLOB headers "OSX*.h" "IOSX*.h")
    file(GLOB sources "OSX*.cpp" "IOSX*.cpp" "OSX*.m" "OSX*.mm")
elseif (UNIX)
    file(GLOB headers "XWindows*.h")
    file(GLOB sources "XWindows*.cpp")
endif()

if (SYNERGY_ADD_HEADERS)
    list(APPEND sources ${headers})
endif()

if (APPLE)
    list(APPEND inc
        /System/Library/Frameworks
    )
endif()

include_directories(${inc})
add_library(platform STATIC ${sources})
target_link_libraries(platform client ${libs})

if (UNIX)
    target_link_libraries(platform io net ipc synlib client ${libs})
endif()

if (APPLE)
    find_library(COCOA_LIBRARY Cocoa)
    target_link_libraries(platform ${COCOA_LIBRARY})
endif()

=== debian/changelog ===
synergy (1.14.1.32+dfsg-1~mx21+1) mx; urgency=medium

  * Initial build from upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 11 Nov 2021 14:34:39 -0500

synergy (1.14.1.32+dfsg-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #7016 Fix script that generates version number
    - #7006 Resolve code scanning issues
    - #7012 Fix natural horizontal scrolling on Mac client
    - #6997 Allow Windows to go to sleep depending on system preferences
    - #7001 Add option to prevent computer from going to sleep
    - #7029 | #7033 Wrong encoding for text copied between linux and windows
    - #7015 Fix Windows service not starting up after sleep
    - #7036 Fix tray icon not changing theme on Big Sur
    - #7046 Fix MacOS 10.13 build
    - #7049 Scroll doesn't work in case of macOS is server
    - #7057 | #7058 Fix copy paste logic, when OS reported about clipboard
      update too late
    - #7055 | #7066 Add secure input notification on Linux
    - #7052 Add secure input notification on Windows
    - #7047 | #7060 Fix prevent sleep option on Mac and Windows
    - #7064 There is no secure input notification if user moves pointer between
      clients
   - Enhancements:
    - #6998 Remove functionality related to the screen saver synchronisation
    - #7026 Update the way we package OpenSSL for Windows build
    - #7035 Add Fedora 34 build
    - #7037 Add Ubuntu 21.04 build
    - #7030 | #7041 | #7043 Add user notification for secure input on Mac
    - #7044 Apply natural scroll setting independently on each client
    - #7040 Support "Kana" and "Eisu" keys on Japanese Apple Pro Keyboard (JIS)
    - #7047 Add prevent sleep option support to Linux

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Thu, 16 Sep 2021 11:24:42 +0000

synergy (1.14.0.4+dfsg-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #6953 | #6961 The system does not update server name in Server
      configuration
    - #6966 macOS 10.13 missing build number
    - #6968 System loses synchronisation between settings and configuration
    - #6972 Fix SonarCloud security hotspots
    - #6971 Fix vulnerabilities from SonarCloud
    - #6974 Fix macOS 10.13 application files
    - #6975 Fix server stop working
    - #6976 Fix windows builds
    - #6979 Manual config error in client mode
    - #6983 Fix that mac client listens on ipv4 only
    - #6989 Fix client tray language switcher reverts to EN
    - #6993 Fix issues with prefences UI
    - #6992 UI issues and use cases
    - #7000 Additional UI tweaks
    - #7005 Fix User is not able to connect to server using ipv6 without
      wrapping IP in square quotes
    - #7009 Clipboard sharing doesn't work on Linux system
    - #7010 Fix Ubuntu 16.04 pipeline in Azure
    - #7011 Fix language synchronisation checkbox spelling
    - #7013 Wrong connection pop up appears if the user connects using a domain
      name which is assigned to list of IP's
    - #7014 Temporary disable language sync logic
    - #7020 Remove cmake option for autoconfig
   - Enhancements:
    - #6954 Move language selection to advanced section
    - #6959 Update synergy UI. Setup wizard
    - #6969 Update synergy UI. Validation for aliases.
    - #6973 Update synergy UI. Main window
    - #6977 Update synergy UI. Configure server
    - #6978 Update synergy UI. Settings window
    - #6981 | #6987 | #6988 | #6996 Update synergy UI. Setup client
      configuration
    - #6984 Update synergy UI. Client error messages
    - #6962 | #6965 Add macOS 10.13 builder
    - #6990 Change VersionChecker URL and include system language in the header
    - #6999 Detect if Linux is running with Wayland, and display a warning
      message
    - #7003 | #7024 Prioritization rules server config
    - #7004 Add openssl dependency for rpm
    - #7008 Add logging when hostname have several IP
    - #7022 Add Fedora 33 to build and release pipeline
    - #7031 New china licenses

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sat, 12 Jun 2021 09:12:45 +0000

synergy (1.13.1.41-1~xtradeb1) focal; urgency=medium

  * New upstream release.
   - Bug fixes:
    - #6900 Remaining SonarCloud reported bug items
    - #6903 Save global settings
    - #6889 Systray Icon on Ubuntu Auto Start (take 2)
    - #6907 Saving configuration on apply
    - #6934 Text on welcome screen on macOS is shown without spaces
    - #6920 Windows Installer checksums
    - #6921 Handling pre-main window creation status notifications
    - #6922 macOS CI build
    - #6927 Text copied and pasted between Windows and Mac OS converts to
      Japanese
    - #6936 Application loses settings
    - #6939 Update pipelines to use correct credentials
    - #6942 All the text in all the windows should have the same font and size
    - #6944 Systray icon is incorrect for macOS Big Sur
    - #6941 The application doesn't recognize old settings
    - #6945 Fix build for Raspberry Pi
    - #6946 Add build stage to filename
    - #6950 Synergy client doesn't save the server address when rebooted
    - #6951 Fix issue creating standard version for Raspberry Pi
   - Enhancements:
    - #6912 Removes UI for Screen Saver Sync and Files Drag and Drop
    - #6909 Document CLI Arguments
    - #6916 Main Window receives screen name change
    - #6910 Don't use the word “Version” for release names because it can lead
      to errors during update checking.
    - #6918 Removing positional union initialisation
    - #6931 Update build pipeline to support macOS 10.13
    - #6937 Modern C++ compiler for centOS7
    - #6938 Remove auto config message from the main window
    - #6941 Add Raspberry Pi Builds
    - #6949 Add a new option SYNERGY_AUTOCONFIG to exclude autoconfig from the
      standard version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sun, 14 Mar 2021 13:24:22 +0000

synergy (1.13.0-1~xtradeb2) focal; urgency=medium

  * Include watch file



=== debian/control ===
Source: synergy
Section: utils
Priority: optional
Standards-Version: 4.5.0
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Symless <engineering@symless.com>, Jhonny Oliveira <jhonny.oliveira@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libavahi-compat-libdnssd-dev,
               libssl-dev,
               libxt-dev,
               libxtst-dev,
               libx11-dev,
               libxi-dev,
               libxrandr-dev,
               libxinerama-dev,
               qtbase5-dev,
               qttools5-dev,
               googletest,
               libglib2.0-dev,
               libgdk-pixbuf2.0-dev,
               libnotify-dev
Homepage: https://symless.com/synergy

Package: synergy
Architecture: any
Section: utils
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Keyboard and mouse sharing solution
 Synergy allows you to share one mouse and keyboard between multiple computers.
 Work seamlessly across Windows, macOS and Linux.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export BUILDDIR=.build

%:
	dh $@ --builddir=$(BUILDDIR)

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_clean:
	rm -Rf ext/googletest/*
	dh_auto_clean

override_dh_auto_configure:
	cp -r /usr/src/googletest/* ext/googletest/
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
	$(BUILDDIR)/bin/unittests
	$(BUILDDIR)/bin/integtests

=== debian/watch ===
version=4
opts="dversionmangle=s!\+dfsg!!, \
      oversionmangle=s!(.+)!$1+dfsg!" \
 https://github.com/symless/synergy-core/releases/latest \
    (?:.*/)?v?([\d\.]+)(?:-stable)?\.tar\.gz
